SystemOrganization addCategory: #'Spec-Builder'!
SystemOrganization addCategory: #'Spec-Builder-Tools'!
SystemOrganization addCategory: #'Spec-Builder-Importer'!
SystemOrganization addCategory: #'Spec-Builder-Generated'!

!ListComposableModel class methodsFor: '*Spec-Builder' stamp: 'bvr 5/31/2012 13:36'!
possibleEvents

	^ #(whenListChanged whenSelectionChanged whenSelectedItemChanged whenSelectedIndexChanged)! !

!PickListModel class methodsFor: '*Spec-Builder' stamp: 'BenjaminVanRyseghem 2/28/2012 14:17'!
possibleEvents

	^ #(whenListChanges whenSelectionChanges whenSelectedItemChanges whenSelectedIndexChanges whenPickeItemsChanges)! !

!Class methodsFor: '*Spec-Builder' stamp: 'BenjaminVanRyseghem 3/5/2012 05:50'!
addInstVarNamed: aName type: aClass

	^ self addInstVarNamed: aName! !

!Class methodsFor: '*Spec-Builder' stamp: 'BenjaminVanRyseghem 2/28/2012 20:27'!
addSourceCode: source into: selector
	| method newSource |
	method := self methodDict at: selector asSymbol ifAbsent: [ ^ self ].
	newSource := String streamContents: [:s |
		s << method sourceCode << '.' ; cr ; tab ;<< source ].
	self compileWithoutReturn: newSource classified: method category! !

!Class methodsFor: '*Spec-Builder' stamp: 'BenjaminVanRyseghem 2/27/2012 07:45'!
subclass: newName category: newCategory

	| result |
	result := self subclass: newName
					instanceVariableNames: ''
					classVariableNames: ''
					poolDictionaries: ''
					category: newCategory.
	^ result 
		ifNil: [ Smalltalk at: name ifAbsent: [ nil ]]
		ifNotNil: [ result ]! !

!TextModel class methodsFor: '*Spec-Builder' stamp: 'bvr 5/31/2012 13:34'!
possibleEvents

	^ #(whenTextChanged:)! !

Object subclass: #AbstractDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Builder'!

!AbstractDescription methodsFor: 'processing' stamp: 'BenjaminVanRyseghem 2/27/2012 07:35'!
generate

	^ self generateSpec asOrderedCollection addFirst: #model; asArray! !

!AbstractDescription methodsFor: 'processing' stamp: 'BenjaminVanRyseghem 2/27/2012 06:44'!
generateSpec

	^ self subclassResponsibility! !

AbstractDescription subclass: #AddClassDescription
	instanceVariableNames: 'category name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Builder'!

!AddClassDescription class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 2/27/2012 07:38'!
category: ctgr name: newClassName

	^ self new
		category: ctgr;
		newClassName: newClassName;
		yourself! !

!AddClassDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 07:12'!
category
	^ category! !

!AddClassDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 07:12'!
category: anObject
	category := anObject! !

!AddClassDescription methodsFor: 'processing' stamp: 'BenjaminVanRyseghem 2/27/2012 07:45'!
generateSpec

	^ {	#subclass:category:.
		self newClassName asSymbol.
		self category}
		! !

!AddClassDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 07:13'!
newClassName

	^ name! !

!AddClassDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 07:13'!
newClassName: anObject

	name := anObject! !

AbstractDescription subclass: #AddInstVarDescription
	instanceVariableNames: 'name type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Builder'!

!AddInstVarDescription class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 2/28/2012 13:56'!
name: newName

	^ self 
		name: newName
		type: Object! !

!AddInstVarDescription class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 2/28/2012 13:56'!
name: newName type: type

	^ self new
		name: newName;
		type: type;
		yourself! !

!AddInstVarDescription methodsFor: 'processing' stamp: 'BenjaminVanRyseghem 3/5/2012 05:51'!
generateSpec

	^ { #addInstVarNamed:type:.	self name. self type }! !

!AddInstVarDescription methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/27/2012 06:48'!
initialize
	"Initialization code for AddInstVarDescription"

	super initialize.

	name := ''.! !

!AddInstVarDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 06:41'!
name
	^ name! !

!AddInstVarDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 06:40'!
name: anObject
	name := anObject! !

!AddInstVarDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 13:55'!
type
	^ type! !

!AddInstVarDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 13:55'!
type: anObject
	type := anObject! !

AbstractDescription subclass: #AddIntoMethodDescription
	instanceVariableNames: 'code order selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Builder'!

!AddIntoMethodDescription class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 2/27/2012 07:09'!
code: code order: order selector: selector

	^ self new
		code: code;
		order: order;
		selector: selector;
		yourself! !

!AddIntoMethodDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 07:09'!
code
	^ code! !

!AddIntoMethodDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 07:09'!
code: anObject
	code := anObject! !

!AddIntoMethodDescription methodsFor: 'processing' stamp: 'BenjaminVanRyseghem 2/27/2012 08:00'!
generateSpec
	
	^ { #addSourceCode:into:. self code. self selector }! !

!AddIntoMethodDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 07:09'!
order
	^ order! !

!AddIntoMethodDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 07:09'!
order: anObject
	order := anObject! !

!AddIntoMethodDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 07:09'!
selector
	^ selector! !

!AddIntoMethodDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 07:09'!
selector: anObject
	selector := anObject! !

AbstractDescription subclass: #AddMethodDescription
	instanceVariableNames: 'category selector source'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Builder'!

!AddMethodDescription class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 2/27/2012 07:00'!
category: category source: source

	^ self new
		category: category;
		source: source;
		yourself! !

!AddMethodDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 06:47'!
category
	^ category! !

!AddMethodDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 06:47'!
category: anObject
	category := anObject! !

!AddMethodDescription methodsFor: 'processing' stamp: 'BenjaminVanRyseghem 2/27/2012 07:50'!
generateSpec
	
	^ { #compileWithoutReturn:classified:.	self source.	self category.}! !

!AddMethodDescription methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/27/2012 07:07'!
initialize
	"Initialization code for AddMethodDescription"

	super initialize.

	category := ''.
	selector := ''.
	source := ''.! !

!AddMethodDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 06:41'!
selector
	^ selector! !

!AddMethodDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 06:41'!
selector: anObject
	selector := anObject! !

!AddMethodDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 06:41'!
source
	^ source! !

!AddMethodDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 06:41'!
source: anObject
	source := anObject! !

AbstractDescription subclass: #ComposableModelDescription
	instanceVariableNames: 'addClassDescription addInstVarDescriptions addMethodDescriptions addIntoMethodDescriptions specDescription superclass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Builder'!

!ComposableModelDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 14:07'!
addClassDescription

	^ addClassDescription! !

!ComposableModelDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/5/2012 05:43'!
addClassDescription: aDescription

	addClassDescription := aDescription! !

!ComposableModelDescription methodsFor: 'protocol-basic' stamp: 'BenjaminVanRyseghem 2/28/2012 20:18'!
addClassNamed: name categorized: category

	addClassDescription := AddClassDescription
								category: category
								name: name.
								
	self addMethodWithSource: 'initialize
	
	super initialize' category: 'initialize'.! !

!ComposableModelDescription methodsFor: 'protocol-basic' stamp: 'BenjaminVanRyseghem 2/27/2012 08:01'!
addCodeTo: selector source: source order: order

	addIntoMethodDescriptions add: (AddIntoMethodDescription 
													code: source
													order: order
													selector: selector).! !

!ComposableModelDescription methodsFor: 'protocol-basic' stamp: 'BenjaminVanRyseghem 2/27/2012 07:56'!
addCodeToInitialize: source order: order

	addIntoMethodDescriptions add: (AddIntoMethodDescription 
													code: source
													order: order
													selector: #initialize).! !

!ComposableModelDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 06:58'!
addInstVarDescriptions
	^ addInstVarDescriptions! !

!ComposableModelDescription methodsFor: 'protocol-basic' stamp: 'BenjaminVanRyseghem 3/1/2012 21:45'!
addInstVarNamed: aString

	addInstVarDescriptions add: (AddInstVarDescription name: aString).
	self addMethodWithSource: aString, '
	
	^ ', aString category: 'accessing'! !

!ComposableModelDescription methodsFor: 'protocol-basic' stamp: 'BenjaminVanRyseghem 3/1/2012 21:53'!
addInstVarNamed: aString kindOf: aClass

	addInstVarDescriptions add: (AddInstVarDescription name: aString type: aClass).
	self addMethodWithSource: aString, '
	
	^ ', aString category: 'accessing'! !

!ComposableModelDescription methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/28/2012 14:01'!
addInstVarNamed: aString kindOf: aClass order: order

	self addInstVarNamed: aString kindOf: aClass.
	self addCodeToInitialize: aString, ' := ', aClass name, ' new' order: order! !

!ComposableModelDescription methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/27/2012 08:09'!
addInstVarNamed: aString kindOfComposablaeModel: aComposableModelClass

	self addInstVarNamed: aString kindOfComposablaeModel: aComposableModelClass order: 0! !

!ComposableModelDescription methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/28/2012 14:01'!
addInstVarNamed: aString kindOfComposablaeModel: aComposableModelClass order: order

	self addInstVarNamed: aString kindOf: aComposableModelClass.
	self addCodeToInitialize: aString, ' := self instantiate: ', aComposableModelClass name order: order! !

!ComposableModelDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 07:55'!
addIntoMethodDescriptions
	^ addIntoMethodDescriptions! !

!ComposableModelDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 06:58'!
addMethodDescriptions
	^ addMethodDescriptions! !

!ComposableModelDescription methodsFor: 'protocol-basic' stamp: 'BenjaminVanRyseghem 2/27/2012 07:48'!
addMethodWithSource: source category: category

	addMethodDescriptions add: (AddMethodDescription
										category: category
										source: source)! !

!ComposableModelDescription methodsFor: 'processing' stamp: 'BenjaminVanRyseghem 3/29/2012 10:14'!
finalize

	^ SpecInterpreter interpretASpec: self generate model: self superclass! !

!ComposableModelDescription methodsFor: 'processing' stamp: 'BenjaminVanRyseghem 3/2/2012 06:06'!
generateSpec
	| spec |
	spec := OrderedCollection new 
		addAll: (addClassDescription generateSpec);
		addAll: (addInstVarDescriptions gather: #generateSpec);
		addAll: (addMethodDescriptions gather: #generateSpec);
		addAll: ((addIntoMethodDescriptions sort: [:a :b | a order < b order ]) gather: #generateSpec);
		add: #theMetaClass;
		addAll: specDescription generate;
		add: #theNonMetaClass;
		yourself.
		
	^ spec addAll: {#theMetaClass. #compileWithoutReturn:classified:. 'generatingSpec
	
	^ ', (spec copy addFirst: #model;yourself) asArray storeString. 'generating'};yourself! !

!ComposableModelDescription methodsFor: 'initialization' stamp: 'bvr 5/31/2012 13:40'!
initialize
	"Initialization code for ComposableModelDescription"

	super initialize.
	
	addClassDescription := AddClassDescription new.
	addInstVarDescriptions := OrderedCollection new.
	addIntoMethodDescriptions := OrderedCollection new.
	addMethodDescriptions := OrderedCollection new.
	specDescription := SpecDescription new.
	
	superclass := ComposableModel.! !

!ComposableModelDescription methodsFor: 'protocol-basic' stamp: 'BenjaminVanRyseghem 3/30/2012 17:10'!
removeInstVar: anInstVar

	addInstVarDescriptions remove: anInstVar.! !

!ComposableModelDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/2/2012 05:56'!
specDescription

	^ specDescription! !

!ComposableModelDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/5/2012 06:22'!
specDescription: aDescription

	specDescription := aDescription! !

!ComposableModelDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/29/2012 10:14'!
superclass
	^ superclass! !

!ComposableModelDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/29/2012 10:14'!
superclass: anObject
	superclass := anObject! !

AbstractDescription subclass: #SpecDescription
	instanceVariableNames: 'selector adds extra'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Builder'!

!SpecDescription methodsFor: 'protocol' stamp: 'bvr 6/4/2012 14:54'!
addInstVar: name fraction: fraction offset: offset
	
	self addInstVar: name spec: #defaultSpec fraction: fraction offset: offset! !

!SpecDescription methodsFor: 'protocol' stamp: 'bvr 6/4/2012 12:18'!
addInstVar: name spec: spec fraction: fraction offset: offset
	| col sub |
	
	spec
		ifNil: [ sub := {#model. name asSymbol} ]
		ifNotNil: [ sub := {#model. name asSymbol. spec asSymbol.} ].
	
	col := {#add:.	{sub.
											#layout:. 	{#LayoutFrame.
																#fractions:offsets:.	 fraction.	offset. }}}.
	adds add: col.! !

!SpecDescription methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/29/2012 10:22'!
addInstVarWrapper: wrapper

	adds add:  {#add:.	wrapper}.! !

!SpecDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/3/2012 01:35'!
adds

	^ adds contents! !

!SpecDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/3/2012 01:42'!
addsHolder

	^ adds! !

!SpecDescription methodsFor: 'private' stamp: 'bvr 6/4/2012 17:10'!
beginSpec

	^ #(ComposableSpec)! !

!SpecDescription methodsFor: 'private' stamp: 'bvr 6/4/2012 17:10'!
endSpec

	^ #()! !

!SpecDescription methodsFor: 'processing' stamp: 'BenjaminVanRyseghem 3/2/2012 06:21'!
generate
	| source |
	source := String streamContents: [:s | 
		s << self selector; cr;tab; << '<spec>';cr;tab;<<'^ ' ;<< self generateSpec printString ].
	
	^ { #compileWithoutReturn:classified:. source.	 'specs'.}! !

!SpecDescription methodsFor: 'processing' stamp: 'BenjaminVanRyseghem 3/2/2012 06:07'!
generateSpec
	| spec |
	spec := OrderedCollection new.
	spec addAll: self beginSpec.
	adds do: [:source | spec addAll: source ].
	spec addAll: self endSpec.
	^ spec asArray! !

!SpecDescription methodsFor: 'initialization' stamp: 'bvr 6/4/2012 14:54'!
initialize
	"Initialization code for SpecDescription"

	super initialize.

	adds := OrderedCollection new asValueHolder.
	selector := #defaultSpec.
	extra := ''.! !

!SpecDescription methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/2/2012 05:42'!
selector

	^ selector! !

!SpecDescription methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/2/2012 05:36'!
selector: aSelector

	selector := aSelector! !

!SpecDescription methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/2/2012 05:32'!
setExtra: source

	extra := source! !

Object subclass: #SpecBuilder
	instanceVariableNames: 'toto titi'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Builder'!

!SpecBuilder class methodsFor: 'experimentation' stamp: 'BenjaminVanRyseghem 2/28/2012 14:04'!
example
	| cmd |
	cmd := ComposableModelDescription new.
	cmd addClassNamed: #SpecTest categorized: 'Spec-Builder'.
	cmd addInstVarNamed: 'toto' kindOfComposablaeModel: TextModel.
	cmd addInstVarNamed: 'titi' kindOf: NewValueHolder.
	cmd addMethodWithSource: 'test1 ^1' category: 'test'.
	cmd addMethodWithSource: 'test2 ^2' category: 'test'.
	cmd addCodeToInitialize: 'self test2.' order: 2.
	cmd addCodeToInitialize: 'self test1' order: 1.

	SpecInterpreter interpretASpec: cmd generate model: ComposableModel.


! !

!SpecBuilder class methodsFor: 'experimentation' stamp: 'BenjaminVanRyseghem 3/29/2012 10:15'!
example2
	| d spec desc |
	d := ComposableModelDescription new addClassNamed: 'NewClass2' categorized: 'Spec-Builder'.

	InstVarSetter new
		description: d;
		openWithSpec.
		
	SpecSetter new
		description: d;
		openWithSpec.
		
	d finalize.
	spec := NewClass2 generatingSpec.
	desc := (SpecImporter import: spec).

	desc finalize! !

!SpecBuilder class methodsFor: 'experimentation' stamp: 'BenjaminVanRyseghem 2/27/2012 06:36'!
exp1

	^{#model.
		#addInstVarNamed:. 'toto'.
		#compile:classified:. 	'method	^ true'. 'test'}! !

!SpecBuilder methodsFor: 'test' stamp: 'BenjaminVanRyseghem 2/27/2012 06:57'!
iAmATest

	^ 'I am a test'! !

!SpecBuilder methodsFor: 'test' stamp: 'BenjaminVanRyseghem 2/27/2012 06:36'!
method	^ true! !

Object subclass: #SpecImporter
	instanceVariableNames: 'desc order'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Builder-Importer'!

SpecImporter subclass: #SpecDescriptionImporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Builder-Importer'!

!SpecDescriptionImporter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 3/5/2012 06:21'!
defaultDescription

	^ SpecDescription new! !

!SpecDescriptionImporter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 3/29/2012 10:22'!
import: aSpec

	| copy first |
	copy := aSpec asOrderedCollection copy.
	first := copy removeFirst.
	first = #Panel
		ifTrue: [
			copy removeFirst.
			^ self import: copy ].
	first = #add:
		ifTrue: [ 
				desc addInstVarWrapper: copy removeFirst.
				^ self import: copy ].
	^ desc! !

!SpecImporter class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 3/5/2012 06:21'!
import: aSpec

	^ self new
		import: aSpec! !

!SpecImporter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 3/5/2012 06:21'!
defaultDescription

	^ ComposableModelDescription new! !

!SpecImporter methodsFor: 'importing' stamp: 'BenjaminVanRyseghem 3/29/2012 10:08'!
import: aSpec

	| copy first |
	copy := aSpec asOrderedCollection copy.
	first := copy removeFirst.
	first = #model
		ifTrue: [ ^ self import: copy ].
	first = #subclass:category:
		ifTrue: [ | category name | 
			name := copy removeFirst.
			category := copy removeFirst.
			desc addClassDescription: (AddClassDescription category: category name: name).
			^ self import: copy ].
	first = #addInstVarNamed:type:
		ifTrue: [ 
			desc addInstVarDescriptions add: (AddInstVarDescription name: copy removeFirst type: copy removeFirst).
			^ self import: copy ].
	first = #compileWithoutReturn:classified:
		ifTrue: [ | category source |
			source := copy removeFirst.
			category := copy removeFirst.
			desc addMethodDescriptions add: (AddMethodDescription category: category source: source).
			^ self import: copy ].
	first = #addSourceCode:into:
		ifTrue: [
			desc addIntoMethodDescriptions add: (AddIntoMethodDescription code: copy removeFirst order: order selector: copy removeFirst).
			order := order +1.
			^ self import: copy ].
	first = #theMetaClass
		ifTrue: [ | source index newSpec |
			"for now I only compile method on class side"
			copy removeFirst.
			source := copy removeFirst.
			index := source indexOf: ${.
			source := source copyFrom: index to: source size.
			newSpec := self class compilerClass evaluate: source.
			desc specDescription: (SpecDescriptionImporter import: newSpec).
			^ self import: copy ].
	^ desc.! !

!SpecImporter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 3/5/2012 06:21'!
initialize
	"Initialization code for SpecImporter"

	super initialize.
	desc := self defaultDescription.
	order := 0! !

!ClassDescription methodsFor: '*Spec-Builder' stamp: 'BenjaminVanRyseghem 2/27/2012 07:50'!
compileWithoutReturn: code classified: heading

	self compile: code classified: heading! !

ComposableModel subclass: #ClassNameSetter
	instanceVariableNames: 'classNameLabel classNameTextField categoryLabel categoryField toolbar descriptionHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Builder-Tools'!

!ClassNameSetter class methodsFor: 'specs' stamp: 'bvr 6/4/2012 14:57'!
defaultSpec
	<spec>
	^ {#Panel. #changeProportionalLayout. #'add:'. {#(#model 'classNameLabel' ). #layout:. {#LayoutFrame. #fractions:offsets:. (0@0) corner: (1@0). (0@0) corner: (0@25)}}. #'add:'. {#(#model 'classNameTextField' ). #layout:. {#LayoutFrame. #fractions:offsets:. (0@0) corner: (1@0). (0@30) corner: (0@65)}}. #'add:'. {#(#model 'categoryLabel' ). #layout:. {#LayoutFrame. #fractions:offsets:. (0@0) corner: (1@0). (0@70) corner: (0@95)}}. #'add:'. {#(#model 'categoryField' ). #layout:. {#LayoutFrame. #fractions:offsets:. (0@0) corner: (1@0). (0@100) corner: (0@135)}}. #add:. {#(#model #toolbar ). #layout:. {#LayoutFrame. #fractions:offsets:. (0@1) corner: (1@1). (0@ -25) corner: (0@0)}}. #vResizing:. #spaceFill. #hResizing:. #spaceFill}! !

!ClassNameSetter class methodsFor: 'generating' stamp: 'BenjaminVanRyseghem 3/30/2012 14:38'!
generatingSpec
	
	^ ((Array new: 57) at: 1 put: #model; at: 2 put: #subclass:category:; at: 3 put: #ClassNameSetter; at: 4 put: 'Spec-Builder-Tools'; at: 5 put: #addInstVarNamed:type:; at: 6 put: 'classNameLabel'; at: 7 put: LabelModel; at: 8 put: #addInstVarNamed:type:; at: 9 put: 'classNameTextField'; at: 10 put: TextInputFieldModel; at: 11 put: #addInstVarNamed:type:; at: 12 put: 'categoryLabel'; at: 13 put: LabelModel; at: 14 put: #addInstVarNamed:type:; at: 15 put: 'categoryField'; at: 16 put: TextInputFieldModel; at: 17 put: #addInstVarNamed:type:; at: 18 put: 'toolbar'; at: 19 put: OkCancelToolbar; at: 20 put: #compileWithoutReturn:classified:; at: 21 put: 'initialize
	
	super initialize'; at: 22 put: 'initialize'; at: 23 put: #compileWithoutReturn:classified:; at: 24 put: 'classNameLabel
	
	^ classNameLabel'; at: 25 put: 'accessing'; at: 26 put: #compileWithoutReturn:classified:; at: 27 put: 'classNameTextField
	
	^ classNameTextField'; at: 28 put: 'accessing'; at: 29 put: #compileWithoutReturn:classified:; at: 30 put: 'categoryLabel
	
	^ categoryLabel'; at: 31 put: 'accessing'; at: 32 put: #compileWithoutReturn:classified:; at: 33 put: 'categoryField
	
	^ categoryField'; at: 34 put: 'accessing'; at: 35 put: #compileWithoutReturn:classified:; at: 36 put: 'toolbar
	
	^ toolbar'; at: 37 put: 'accessing'; at: 38 put: #addSourceCode:into:; at: 39 put: 'toolbar := self instantiate: OkCancelToolbar'; at: 40 put: #initialize; at: 41 put: #addSourceCode:into:; at: 42 put: 'categoryField := self instantiate: TextInputFieldModel'; at: 43 put: #initialize; at: 44 put: #addSourceCode:into:; at: 45 put: 'categoryLabel := self instantiate: LabelModel'; at: 46 put: #initialize; at: 47 put: #addSourceCode:into:; at: 48 put: 'classNameTextField := self instantiate: TextInputFieldModel'; at: 49 put: #initialize; at: 50 put: #addSourceCode:into:; at: 51 put: 'classNameLabel := self instantiate: LabelModel'; at: 52 put: #initialize; at: 53 put: #theMetaClass; at: 54 put: #compileWithoutReturn:classified:; at: 55 put: 'internSpec
	<spec>
	^ {#Panel. #changeProportionalLayout. #''add::''. {#(#model ''classNameLabel'' ''internSpec''). #layout:. {#LayoutFrame. #fractions:offsets:. (0@0) corner: (1@0). (0@0) corner: (0@25)}}. #''add::''. {#(#model ''classNameTextField'' ''internSpec''). #layout:. {#LayoutFrame. #fractions:offsets:. (0@0) corner: (1@0). (0@30) corner: (0@45)}}. #''add::''. {#(#model ''categoryLabel'' ''internSpec''). #layout:. {#LayoutFrame. #fractions:offsets:. (0@0) corner: (1@0). (0@50) corner: (0@75)}}. #''add::''. {#(#model ''categoryField'' ''internSpec''). #layout:. {#LayoutFrame. #fractions:offsets:. (0@0) corner: (1@0). (0@80) corner: (0@105)}}. #add:. {#(#model #toolbar #internSpec). #layout:. {#LayoutFrame. #fractions:offsets:. (0@1) corner: (1@1). (0@ -25) corner: (0@0)}}. #vResizing:. #spaceFill. #hResizing:. #spaceFill}'; at: 56 put: 'specs'; at: 57 put: #theNonMetaClass; yourself)! !

!ClassNameSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/30/2012 14:38'!
categoryField
	
	^ categoryField! !

!ClassNameSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/30/2012 14:38'!
categoryLabel
	
	^ categoryLabel! !

!ClassNameSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/30/2012 14:38'!
classNameLabel
	
	^ classNameLabel! !

!ClassNameSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/30/2012 14:38'!
classNameTextField
	
	^ classNameTextField! !

!ClassNameSetter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/30/2012 17:28'!
description: aDescription

	descriptionHolder contents: aDescription! !

!ClassNameSetter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/30/2012 15:34'!
initialExtent

	^  (300@200)! !

!ClassNameSetter methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 6/12/2012 19:08'!
initialize
	
	descriptionHolder := nil asValueHolder.
	super initialize.
	! !

!ClassNameSetter methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 6/12/2012 18:54'!
initializePresenter

	toolbar okAction: [ 
		classNameTextField getText ifNotNil: [:cn |
			categoryField getText ifNotNil: [:cat |
				descriptionHolder contents
									addClassNamed: cn
									categorized: cat  ]]].
	
	descriptionHolder whenChangedDo: [:desc || acDesc | 
		acDesc:= desc addClassDescription.
		classNameTextField text: acDesc newClassName.
		categoryField text: acDesc category ]! !

!ClassNameSetter methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 6/12/2012 18:55'!
initializeWidgets

	self instantiateModels: #(
		toolbar OkCancelToolbar
		categoryField TextInputFieldModel
		categoryLabel LabelModel
		classNameTextField TextInputFieldModel
		classNameLabel LabelModel ).
	
	categoryField autoAccept: true.
	classNameTextField autoAccept: true.
	
	classNameLabel text: 'Class name:'.
	categoryLabel text: 'Category:'.! !

!ClassNameSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/30/2012 14:38'!
toolbar
	
	^ toolbar! !

!ComposableModel class methodsFor: '*Spec-Builder' stamp: 'bvr 5/31/2012 13:39'!
bindings 

	^ BindingsHolder new! !

!ComposableModel class methodsFor: '*Spec-Builder' stamp: 'BenjaminVanRyseghem 2/28/2012 14:15'!
possibleEvents

	^ #()! !

!ComposableModel class methodsFor: '*Spec-Builder' stamp: 'BenjaminVanRyseghem 3/28/2012 17:59'!
retrieveClassSymbolFor: aSymbol

	^ self bindings classSymbolFor: aSymbol ifAbsent: [ aSymbol ]! !

!ComposableModel class methodsFor: '*Spec-Builder' stamp: 'BenjaminVanRyseghem 3/28/2012 17:59'!
retrieveSelectorSymbolFor: aSymbol

	^ self bindings selectorSymbolFor: aSymbol ifAbsent: [ aSymbol ]! !

ComposableModel subclass: #InstVarAdder
	instanceVariableNames: 'description nameField nameLabel toolbar typeField typeLabel typeChoice selectedClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Builder-Tools'!

!InstVarAdder class methodsFor: 'specs' stamp: 'bvr 6/4/2012 14:45'!
defaultSpec
	<spec>
	| height width |
	height := 25.
	width := (StandardFonts defaultFont widthOfString: 'Name:') + 10.
	^ { #ComposableSpec.
			#add:. {{#model. #nameLabel.}.
							#layout:. 	{#FrameLayout.
											#fractions:offsets:.	 ( 0@0 corner: 0.5@1 ).	(0@0 corner: 0@(2*height) negated). }}.
			#add:. {{#model. #nameField.}.
							#layout:. {#FrameLayout.
											#fractions:offsets:.	( 0@0 corner: 1@1 ).	(width@0 negated corner: 0@(2*height) negated). }}.
			#add:. {{#model. #typeLabel.}.
							#layout:. 	{#FrameLayout.
											#fractions:offsets:.	 (0@1 corner: 0.5@1).	(0@(2*height negated) corner: 0@(height negated)). }}.										
			#add:.	{{#model. #typeChoice.}.
							#layout:. 	{#FrameLayout.
											#fractions:offsets:.	 (0@1 corner: 1@1).	(width@(2*height negated) corner: 0@(height negated)). }}.
																		
			#add:.	{{#model. #toolbar.}.
							#layout:. 	{#FrameLayout.
											#fractions:offsets:.	 (0@1 corner: 1@1).	(0@(height negated) corner: 0@0). }}}! !

!InstVarAdder class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/28/2012 21:54'!
title

	^ 'Add an inst var...'! !

!InstVarAdder methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/2/2012 05:54'!
accept
	| name cl |
	nameField accept.
	(name := nameField getText) isEmptyOrNil ifFalse: [
			cl := selectedClass contents.
			cl ifNil: [ cl := ComposableModel ].
			description contents addInstVarNamed: name kindOfComposablaeModel: cl.
			description contentsChanged ]! !

!InstVarAdder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 22:07'!
description
	^ description contents! !

!InstVarAdder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/28/2012 21:34'!
description: aDescription

	description contents: aDescription! !

!InstVarAdder methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/28/2012 21:55'!
initialExtent

	^ 260@115! !

!InstVarAdder methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:08'!
initialize
	"Initialization code for InstVarAdder"	

	description := nil asValueHolder.
	selectedClass := nil asValueHolder.
	super initialize.! !

!InstVarAdder methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 18:56'!
initializePresenter

	toolbar okAction: [ self accept ].! !

!InstVarAdder methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 18:56'!
initializeWidgets


	self instantiateModels: #(
		nameField TextInputFieldModel
		nameLabel LabelModel
		toolbar OkCancelToolbar
		typeChoice DropListModel
		typeLabel LabelModel ).
	
	nameLabel text: 'Name:'.
	nameField 
		autoAccept: true;
		entryCompletion: nil.
	typeLabel text: 'Class:'.
	
	typeChoice items: ((ComposableModel subclasses sort: [:a :b | a name < b name ]) collect: [: e | DropListItem named: e name do: [ selectedClass contents: e ]]) .
	
	self setFocus! !

!InstVarAdder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 20:59'!
nameField
	^ nameField! !

!InstVarAdder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 20:59'!
nameLabel
	^ nameLabel! !

!InstVarAdder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 20:59'!
selectedClass
	^ selectedClass! !

!InstVarAdder methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 3/1/2012 21:46'!
setFocus

	self focusOrder 
		add: nameField;
		add: typeChoice;
		add: toolbar.! !

!InstVarAdder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 20:59'!
toolbar
	^ toolbar! !

!InstVarAdder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 20:59'!
typeChoice
	^ typeChoice! !

!InstVarAdder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 20:59'!
typeField
	^ typeField! !

!InstVarAdder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 20:59'!
typeLabel
	^ typeLabel! !

!InstVarAdder methodsFor: 'protocol-events' stamp: 'bvr 5/31/2012 13:33'!
whenDescriptionChanged: aBlock

	description whenChangedDo: aBlock! !

ComposableModel subclass: #InstVarSetter
	instanceVariableNames: 'list picklist text okCancelToolbar descriptionHolder addButton removeButton textBindings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Builder-Tools'!

!InstVarSetter class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 6/12/2012 19:11'!
defaultSpec
	<spec>
	| delta |
	delta := 25.
	^{ #ComposableSpec.
			#add:. {{#model. #list. }.
							#layout:. 	{#LayoutFrame.
											#fractions:offsets:.	 (0@0 corner: 0.33@1).	(0@0 corner: 0@((2*delta) negated)). }}.						
			#add:. {{#model. #addButton }.
							#layout:. 	{#LayoutFrame.
											#fractions:offsets:.	 (0@1 corner: 0.16@1).	(0@((2*delta) negated) corner: 0@(delta negated)). }}.
			#add:. {{#model. #removeButton }.
							#layout:. 	{#LayoutFrame.
											#fractions:offsets:.	 (0.16@1 corner: 0.33@1).	(0@((2*delta) negated) corner: 0@(delta negated)). }}.
			#add:. {{#model. #picklist }.
							#layout:. 	{#LayoutFrame.
											#fractions:offsets:.	 (0.33@0 corner: 0.66@1).	(0@0 corner: 0@(delta negated)). }}.															
			#add:. {{#model. #text }.
							#layout:. 	{#LayoutFrame.
											#fractions:offsets:.	 (0.66@0 corner: 1@1).		(0@0 corner: 0@(delta negated)). }}.
			#add:. {{#model. #okCancelToolbar }.
							#layout:. 	{#LayoutFrame.
											#fractions:offsets:.	 (0@1 corner: 1@1).		(0@(delta negated) corner: 0@0). }}}! !

!InstVarSetter class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/28/2012 01:40'!
title

	^'Inst var setter'! !

!InstVarSetter methodsFor: 'protocol' stamp: 'bvr 5/31/2012 13:42'!
accept
	| instVars desc |
	desc := descriptionHolder contents.
	desc ifNil: [ ^ self ].
	
	text accept.
	instVars := textBindings select: [:assoc | assoc notNil and: [ assoc values anySatisfy: [:v | v value ]]].
	instVars associations do: [:assoc || instVar source events |
		instVar := assoc key.
		source := String streamContents: [:s | s << 'register' << instVar name capitalized << 'Events'].
		desc addCodeToInitialize: 'self ', source order: 1.
		desc addMethodWithSource: source category: 'initialization'.
		events := assoc value select: [:a | a value ].
		events associations do: [:a || src |
			src := String streamContents: [:s | s << instVar name << ' ' << a key asString << ': '  << a value key  << '.'].
			desc addCodeTo: source source: src order: 1 ]].! !

!InstVarSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 20:32'!
addButton

	^ addButton! !

!InstVarSetter methodsFor: 'private' stamp: 'bvr 5/31/2012 13:33'!
addInstVar
	| adder |
	
	adder := InstVarAdder new.
	adder 
		description: descriptionHolder contents;
		openWithSpec.
		
	adder whenDescriptionChanged: [ self description: adder description ]! !

!InstVarSetter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/1/2012 21:43'!
defaultText
		
	^ '[:new :old :announcement :announcer |  ]'! !

!InstVarSetter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/28/2012 14:20'!
description

	^ descriptionHolder contents! !

!InstVarSetter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/28/2012 14:11'!
description: aDescription

	descriptionHolder contents: aDescription! !

!InstVarSetter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/28/2012 14:20'!
hasBindingOf: aString 
	
	^ self description
		ifNil: [ false ]
		ifNotNil: [:desc | (desc addInstVarDescriptions collect: #name) includes: aString ]! !

!InstVarSetter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/28/2012 14:21'!
hasBindingThatBeginsWith: aString
	
	^ self description
		ifNil: [ false ]
		ifNotNil: [:desc | (desc addInstVarDescriptions collect: #name) anySatisfy: [:name | name beginsWith: aString ]]! !

!InstVarSetter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/28/2012 03:38'!
initialExtent

	^ (700 min: (World extent x)) @ (300 min: (World extent y))! !

!InstVarSetter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:09'!
initialize
	"Initialization code for InstVarSetter"

	descriptionHolder := nil asValueHolder.
	textBindings := Dictionary new.
	super initialize.	! !

!InstVarSetter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 3/29/2012 11:54'!
initializeBindingsFrom: desc
	
	desc addInstVarDescriptions do: [:e || adds | 
		textBindings at: e put: Dictionary new.
		adds := desc addIntoMethodDescriptions select: [:d | d selector = ('register', e name capitalized, 'Events') ].
		 adds do: [:a || source item |
			source :=  a code substrings.
			item := source second allButLast asSymbol.
			(bindings at: e) at: item put: (((source allButFirst:2) joinUsing: ' ')->true) ]].! !

!InstVarSetter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 18:57'!
initializePresenter
	
	okCancelToolbar okAction: [ self accept ].
	addButton action: [ self addInstVar ].
	removeButton action: [ self removeInstVar ].
	
	self registerListEvents.
	self registerPickListEvents.
	self registerDescriptionEvents.
	self registerTextEvents! !

!InstVarSetter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:07'!
initializeWidgets

	self instantiateModels: #(
		list ListComposableModel
		picklist PickListModel
		text TextModel
		okCancelToolbar OkCancelToolbar
		addButton ButtonModel
		removeButton ButtonModel ).

	
	list displayBlock: [:e | e name ].
	picklist labelClickable: false.
	text aboutToStyle: true.
	text enabled: false.
	okCancelToolbar okAction: [ self accept ].

	addButton
		label: '+';
		state: false.
		
	removeButton
		label: '-';
		state: false.! !

!InstVarSetter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/28/2012 14:19'!
inspectedClass

	^ descriptionHolder contents addClassDescription! !

!InstVarSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 02:02'!
list
	^ list! !

!InstVarSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 03:22'!
okCancelToolbar
	^ okCancelToolbar! !

!InstVarSetter methodsFor: 'protocol' stamp: 'bvr 5/31/2012 13:42'!
openWithSpec

	super openWithSpec.
	text widget ifNotNil: [:m | m styler workspace: self ]! !

!InstVarSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 02:02'!
picklist
	^ picklist! !

!InstVarSetter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 3/5/2012 06:52'!
registerDescriptionEvents

	descriptionHolder whenChangedDo: [:desc|| items |
		self initializeBindingsFrom: desc.
		items := desc addInstVarDescriptions select: [:e | e type inheritsFrom: ComposableModel ].
		list items: (items sort: [:a :b | a name < b name ])]! !

!InstVarSetter methodsFor: 'initialization' stamp: 'bvr 5/31/2012 13:33'!
registerListEvents

	list whenSelectedItemChanged: [:instVarDesc |
		instVarDesc
			ifNil: [ picklist items: {} ]
			ifNotNil: [
				picklist items: (instVarDesc type possibleEvents).
				(instVarDesc type possibleEvents) do: [:e |
					(picklist checkboxFor: e) state: ((textBindings at: list selectedItem ifAbsentPut: [ Dictionary new ]) at: e ifAbsentPut: [ self defaultText->false ]) value ]].
		picklist resetSelection.
		text text: '' ]! !

!InstVarSetter methodsFor: 'initialization' stamp: 'bvr 5/31/2012 13:33'!
registerPickListEvents
	
	picklist whenPickedItemsChanged: [:item :old|
		item ifNotNil: [
			((textBindings at: list selectedItem ifAbsentPut: [ Dictionary new ]) at: item ifAbsentPut: [ self defaultText->false ]) value: old ]].
	
	picklist whenSelectedItemChanged: [:item || txt |
		item 
			ifNil: [ 
				text text: ''.
				text enabled: false ]
			ifNotNil: [
				txt := ((textBindings at: list selectedItem ifAbsentPut: [ Dictionary new ]) at: item ifAbsentPut: [ self defaultText->false ]) key.
				text text: txt.
				text enabled: true ]]! !

!InstVarSetter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/11/2012 11:46'!
registerTextEvents

	text acceptBlock: [:txt || item |
		item := picklist selectedItem.
		((textBindings at: list selectedItem ifAbsentPut: [ Dictionary new ]) at: item ifAbsentPut: [ self defaultText->false ]) key: txt .
		(picklist checkboxFor: item) state: true.]! !

!InstVarSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 20:32'!
removeButton

	^ removeButton! !

!InstVarSetter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/30/2012 17:10'!
removeInstVar
	
	descriptionHolder contents removeInstVar: list selectedItem.
	descriptionHolder contentsChanged.! !

!InstVarSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 02:02'!
text
	^ text! !

ComposableModel subclass: #SpecAdder
	instanceVariableNames: 'descriptionHolder fractionField fractionLabel instVars offsetField offsetLabel selectors toolbar selectedInstVar selectedSpec'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Builder-Tools'!

!SpecAdder class methodsFor: 'specs' stamp: 'bvr 6/4/2012 14:53'!
defaultSpec
	<spec>
	| delta |
	delta := 25.
	^{#ComposableSpec.

			#add:.	{{#model.	#instVars.}.
								#layout:. {#LayoutFrame.
												#fractions:offsets:.	(0@0 corner: 1@0). (0@0 corner: 0@delta)}}.
			#add:.	{{#model.	#selectors.}.					
								#layout:. {#LayoutFrame.
												#fractions:offsets:.	(0@0 corner: 1@0). (0@(delta+4) corner: 0@(2*delta+4))}}.							
			#add:.	{{#model.	#fractionLabel.}.
								#layout:. {#LayoutFrame.
												#fractions:offsets:.	(0@0 corner: 1@0). (0@(2*delta+8) corner: 0@(3*delta+8))}}.
			#add:.	{{#model.	#fractionField.}.
								#layout:. {#LayoutFrame.
												#fractions:offsets:.	(0@0 corner: 1@0). (0@(3*delta+12) corner: 0@(4*delta+24))}}.
			#add:.	{{#model. 	#offsetLabel.}.
								#layout:. {#LayoutFrame.
												#fractions:offsets:.	(0@0 corner: 1@0). (0@(4*delta+28) corner: 0@(5*delta+28))}}.
			#add:.	{{#model. 	#offsetField.}.
								#layout:. {#LayoutFrame.
												#fractions:offsets:.	(0@0 corner: 1@0). (0@(5*delta+32) corner: 0@(6*delta+44))}}.		
			#add:.	{{#model.	#toolbar.}.
								#layout:. {#LayoutFrame.
												#fractions:offsets:.	(0@1 corner: 1@1). (0@(delta negated) corner: 0@0)}}}! !

!SpecAdder class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 3/2/2012 07:26'!
title

	^ 'Add a subspec'! !

!SpecAdder methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/2/2012 07:37'!
addInstVar: name spec: specName fraction: fraction offset: offset

	| spec f o |
	f := self class compilerClass evaluate: fraction.
	o := self class compilerClass evaluate: offset.

	spec := descriptionHolder contents specDescription.
	spec addInstVar: name spec: specName fraction: f offset: o! !

!SpecAdder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/2/2012 07:10'!
description: aDescription

	descriptionHolder contents: aDescription.! !

!SpecAdder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/2/2012 07:19'!
fractionField
	^ fractionField! !

!SpecAdder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/2/2012 07:19'!
fractionLabel
	^ fractionLabel! !

!SpecAdder methodsFor: 'display' stamp: 'BenjaminVanRyseghem 3/29/2012 11:49'!
initialExtent

	^  (400@250)! !

!SpecAdder methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:09'!
initialize
	"Initialization code for SpecAdder"

	descriptionHolder := nil asValueHolder.
	selectedInstVar := nil.
	selectedSpec := nil.
	super initialize.! !

!SpecAdder methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:04'!
initializePresenter

	self registerDescriptionEvents.
	self setOkAction! !

!SpecAdder methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:04'!
initializeWidgets

	self instantiateModels: #(
		fractionField TextInputFieldModel
		fractionLabel LabelModel
		instVars DropListModel
		offsetField TextInputFieldModel
		offsetLabel LabelModel
		selectors DropListModel
		toolbar OkCancelToolbar).
	
	self setFieldsAndLabels.! !

!SpecAdder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/2/2012 07:19'!
instVars
	^ instVars! !

!SpecAdder methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/29/2012 16:24'!
modifyAdd: anAdd

	| fractions name spec offsets |

	name := instVars selectedItem asString.
	spec := selectors selectedItem asString.
	fractions := self class compilerClass evaluate:  fractionField getText.
	offsets := self class compilerClass evaluate: offsetField getText.
	
	anAdd second first at: 2 put: name.
	anAdd second first at: 3 put: spec.
	anAdd second third at: 3 put: fractions.
	anAdd second third at: 4 put: offsets.! !

!SpecAdder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/2/2012 07:19'!
offsetField
	^ offsetField! !

!SpecAdder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/2/2012 07:19'!
offsetLabel
	^ offsetLabel! !

!SpecAdder methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 3/2/2012 07:38'!
registerDescriptionEvents
	descriptionHolder
		whenChangedDo: [ :desc | 
			| items |
			instVars
				items: (desc addInstVarDescriptions collect: [ :e | DropListItem named: e name do: [ selectedInstVar := e ] ]).
			selectors
				items: (selectedInstVar type specSelectors collect: [ :e | DropListItem named: e do: [ selectedSpec := e ] ]) ]! !

!SpecAdder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/2/2012 07:19'!
selectors
	^ selectors! !

!SpecAdder methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 3/2/2012 07:39'!
setFieldsAndLabels
	offsetLabel text: 'Offset'.
	fractionLabel text: 'Fractions'.
	offsetField
		ghostText: 'offset';
		autoAccept: true;
		text: '0@0 corner: 0@0'.
	fractionField
		ghostText: 'fraction';
		autoAccept: true;
		text: '0@0 corner: 1@1'! !

!SpecAdder methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 3/2/2012 07:38'!
setOkAction
	toolbar
		okAction: [ 
			(fractionField getText isEmptyOrNil or: [ offsetField getText isEmptyOrNil ])
				ifFalse: [ 
					self
						addInstVar: selectedInstVar name
						spec: selectedSpec
						fraction: fractionField getText
						offset: offsetField getText ] ]! !

!SpecAdder methodsFor: 'importing' stamp: 'BenjaminVanRyseghem 3/29/2012 16:15'!
showFor: anAdd
	"for now an add is badly an array, I should introduce a real object here"
	| fractions name spec offsets |

	name := anAdd second first second asString.
	spec := anAdd second first third asString.
	fractions := anAdd second third third.
	offsets := anAdd second third fourth.
	
	fractionField text: fractions asString.
	offsetField text: offsets asString.
	instVars setSelectedItem: name.
	selectors setSelectedItem: spec.
	
	toolbar okAction: [ self modifyAdd: anAdd ]! !

!SpecAdder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/2/2012 07:19'!
toolbar
	^ toolbar! !

ComposableModel subclass: #SpecSetter
	instanceVariableNames: 'descriptionHolder list addButton removeButton toolbar editButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Builder-Tools'!

!SpecSetter class methodsFor: 'specs' stamp: 'bvr 6/4/2012 14:54'!
defaultSpec
	<spec>
	| delta |
	delta := 25.
	^{ #ComposableSpec.
				#add:.	{{#model. #list.}.
									#layout:. 	{#LayoutFrame.
														#fractions:offsets:.	 (0@0 corner: 1@1).	(0@0 corner: 0@(2*delta negated)). }}.
			#add:.	{{#model. #addButton.}.
									#layout:. 	{#LayoutFrame.
														#fractions:offsets:.	 (0@1 corner: 0.33@1).	(0@(2*delta negated) corner: 0@(delta negated)). }}.
																		
			#add:.	{{#model. #editButton.}.
									#layout:. 	{#LayoutFrame.
														#fractions:offsets:.	 (0.33@1 corner: 0.66@1).	(0@(2*delta negated) corner: 0@(delta negated)). }}.																													
			#add:.	{{#model. #removeButton.}.
									#layout:. 	{#LayoutFrame.
														#fractions:offsets:.	 (0.66@1 corner: 1@1).	(0@(2*delta negated) corner: 0@(delta negated)). }}.															
			#add:.	{{#model. #toolbar.}.
											#layout:. 	{#LayoutFrame.
																#fractions:offsets:.	 (0@1 corner: 1@1).	(0@(delta negated) corner: 0@0). }}}! !

!SpecSetter class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 3/2/2012 23:49'!
title

	^ 'Subspecs'! !

!SpecSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/2/2012 23:04'!
addButton
	^ addButton! !

!SpecSetter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/30/2012 17:35'!
description: aDescription

	descriptionHolder contents: aDescription.
	! !

!SpecSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/2/2012 23:04'!
descriptionHolder
	^ descriptionHolder! !

!SpecSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/29/2012 13:14'!
editButton
	^ editButton! !

!SpecSetter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:09'!
initialize
	"Initialization code for SpecSetter"

	descriptionHolder := nil asValueHolder.
	super initialize.! !

!SpecSetter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:06'!
initializePresenter
	
	addButton action: [ | sa |
			sa := SpecAdder new.
			
			sa description: descriptionHolder contents.
			sa openWithSpec. ].
	
	editButton action: [ | sa |
			sa := SpecAdder new.
			sa openWithSpec.
			sa description: descriptionHolder contents.
			sa showFor: list selectedItem ].
		
	removeButton action: [ self remove ].	
	
	descriptionHolder whenChangedDo: [:desc | list items: desc specDescription adds.
		desc specDescription addsHolder whenChangedDo: [:items | list items: items ] ].! !

!SpecSetter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:05'!
initializeWidgets

	self instantiateModels: #(
		addButton ButtonModel
		list ListComposableModel
		removeButton ButtonModel
		toolbar OkCancelToolbar
		editButton ButtonModel ).
	
	addButton label: '+'.		
	editButton label: 'Edit'.
	removeButton label: '-'.
		
	list displayBlock: [:e | e second first second ].! !

!SpecSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/2/2012 23:04'!
list
	^ list! !

!SpecSetter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/29/2012 13:11'!
remove

	descriptionHolder contents specDescription adds remove: list selectedItem ifAbsent: [ ].
	list items: descriptionHolder contents specDescription adds! !

!SpecSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/2/2012 23:04'!
removeButton
	^ removeButton! !

!SpecSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/2/2012 23:04'!
toolbar
	^ toolbar! !
